package org.ninjasoft.pietrofiles;
import java.io.*;
import java.net.*;
import java.util.*;

public class App implements Runnable {
    public Vector sentences = new Vector();
    
    public void loadSentences(String filename) throws IOException {
        FileInputStream in = new FileInputStream(filename);
        int ch;
        String buffer = "";
        while ((ch = in.read()) != -1) {
            if ((ch == '.') || (ch == '?') || (ch == '"') || (ch == ':')) {
                if (buffer.length() > 0)
                    sentences.add(buffer);
                buffer = "";
            } else if ((ch <= ' ') || (ch == ',')) {
                // Do nothing
            } else {
                buffer += Character.toLowerCase((char) ch);
            }
        }
        in.close();
    }
    
    public void dumpSentences(String filename) throws IOException {
        FileOutputStream out = new FileOutputStream("sentences.txt", false);
        for (Iterator i = sentences.iterator(); i.hasNext(); ) {
            out.write(i.next().toString().getBytes());
            out.write("\n".getBytes());
        }
        out.close();
        out = new FileOutputStream("sentences.html", false);
        out.write("<html><head><title>The Files of Pietro Salk</title><style>a {font-family:monospace}</style></head><body>\n".getBytes());
        for (Iterator i = sentences.iterator(); i.hasNext(); ) {
            String sentence = (String) i.next();
            String line = "<a href=\"http://salkfamily.com/" + sentence + "/\">" + sentence + "</a><br>\n";
            out.write(line.getBytes());
        }
        out.write("</body></html>\n".getBytes());
        out.close();
    }
    
    public int dateLocation(String s) {
        s = s.toLowerCase();
        if (s.indexOf("date:") >= 0)
            return s.indexOf("date:") + 6;
        else if (s.indexOf("january") >= 0)
            return 0;
        else if (s.indexOf("february") >= 0)
            return 0;
        else if (s.indexOf("march") >= 0)
            return 0;
        else if (s.indexOf("april") >= 0)
            return 0;
        else if (s.indexOf("may") >= 0)
            return 0;
        else if (s.indexOf("june") >= 0)
            return 0;
        else if (s.indexOf("july") >= 0)
            return 0;
        else if (s.indexOf("august") >= 0)
            return 0;
        else if (s.indexOf("september") >= 0)
            return 0;
        else if (s.indexOf("october") >= 0)
            return 0;
        else if (s.indexOf("november") >= 0)
            return 0;
        else if (s.indexOf("december") >= 0)
            return 0;
        return -1;
        
    }
    
    public void downloadSentences() throws IOException {
        File dir = new File("./sentences");
        URL url;
        int throttle = 9999;
        dir.mkdir();
        FileOutputStream errors = new FileOutputStream("errors.txt", false);
        errors.close();
        for (Iterator i = sentences.iterator(); (throttle > 0) && i.hasNext(); throttle--) {
            String sentence = (String) i.next();
            System.out.println(sentence);
            InputStream in;
            FileOutputStream out = new FileOutputStream("./tmp.html");
            int len;
            byte block[] = new byte[1024];
            try {
                url = new URL("http://salkfamily.com/" + sentence + "/");
                in = url.openStream();
                while ((len = in.read(block)) > 0) {
                    out.write(block, 0, len);
                }
                in.close();
                out.close();
                LineNumberReader reader = new LineNumberReader(new FileReader("./tmp.html"));
                boolean done = false;
                String line;
                String date = "unknown";
                while (!done && ((line = reader.readLine()) != null)) {
                    int pos;
                    line = line.toLowerCase();
                    pos = dateLocation(line);
                    if (pos >= 0) {
                        done = true;
                        date = line.substring(pos);
                        pos = date.indexOf('<');
                        if (pos > 0)
                            date = date.substring(0, pos);
                        date = date.replace(' ', '_');
                    }
                }
                in = new FileInputStream("./tmp.html");
                out = new FileOutputStream("./sentences/" + date + "-" + sentence + ".html");
                while ((len = in.read(block)) > 0) {
                    out.write(block, 0, len);
                }
                in.close();
                out.close();
            }catch(Throwable t) {
                errors = new FileOutputStream("errors.txt", true);
                System.out.println("ERROR: " + sentence);
                errors.write(("ERROR: " + sentence + "\n").getBytes());
                errors.close();
            }
        }
    }
    
    public void run() {
        try {
            loadSentences("messages.txt");
            dumpSentences("sentences.txt");
            downloadSentences();
        }catch(Throwable t) {
            t.printStackTrace();
        }
    }
    
    public static void main( String[] args )
    {
        new App().run();
    }
}
